<?php

namespace Drupal\sl_base;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

class SlBaseHelper {

  /**
   * @var \Drupal\Core\Entity\EntityTypeManager
   */
  protected $entityTypeManager;

  /**
   * SlBaseHelper constructor.
   *
   * @param \Drupal\Core\Entity\EntityTypeManager $entity_type_manager
   *   The entity type manager.
   */
  public function __construct(EntityTypeManagerInterface $entity_type_manager) {
    $this->entityTypeManager = $entity_type_manager;
  }

  function findTeamPlayers($team) {
    $cached_info = \Drupal::cache()->get('sb_base_team_players_' . $team);
    if (empty($cached_info)) {
      $efq = $this->entityTypeManager->getStorage('node')->getQuery();
      $efq->condition('type', 'sl_person')
        ->condition('status', 1, '=')
        ->accessCheck(FALSE)
        ->condition('field_sl_teams', $team);
      $efq->accessCheck(TRUE);
      $result = $efq->execute();
      $players = \Drupal::entityTypeManager()->getStorage('node')->loadMultiple($result);
      \Drupal::cache()->set('sb_base_team_players_' . $team, $players, time() + (60*60), ['node_list']);
    }
    else {
      $players = $cached_info->data;
    }

    foreach ($players as $player) {
      $player_options[$player->id()] = ['label' => $player->label(), 'number' => $player->field_sl_person_number->value];
    }

    return $player_options;
  }
}